edu.wpi.first.wpilibj.hal

## Class HALUtil

- java.lang.Object
- - edu.wpi.first.wpilibj.hal.JNIWrapper
  - - edu.wpi.first.wpilibj.hal.HALUtil

-     public class HALUtil
      extends JNIWrapper

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `ANALOG_TRIGGER_PULSE_OUTPUT_ERROR`
    `static int` | `INCOMPATIBLE_STATE`
    `static int` | `LOOP_TIMING_ERROR`
    `static int` | `NO_AVAILABLE_RESOURCES`
    `static int` | `NULL_PARAMETER`
    `static int` | `PARAMETER_OUT_OF_RANGE`
    `static int` | `SAMPLE_RATE_TOO_HIGH`
    `static int` | `VOLTAGE_OUT_OF_RANGE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HALUtil()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static boolean` | `getFPGAButton()`
    `static int` | `getFPGARevision()`
    `static long` | `getFPGATime()`
    `static short` | `getFPGAVersion()`
    `static int` | `getHALErrno()`
    `static java.lang.String` | `getHALErrorMessage(int code)`
    `static int` | `getHALRuntimeType()`
    `static java.lang.String` | `getHALstrerror()`
    `static java.lang.String` | `getHALstrerror(int errno)`

    - ### Methods inherited from class edu.wpi.first.wpilibj.hal.JNIWrapper

      `getPort, getPortWithModule`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### NULL_PARAMETER

          public static final int NULL_PARAMETER

      See Also:
        Constant Field Values

    - #### SAMPLE_RATE_TOO_HIGH

          public static final int SAMPLE_RATE_TOO_HIGH

      See Also:
        Constant Field Values

    - #### VOLTAGE_OUT_OF_RANGE

          public static final int VOLTAGE_OUT_OF_RANGE

      See Also:
        Constant Field Values

    - #### LOOP_TIMING_ERROR

          public static final int LOOP_TIMING_ERROR

      See Also:
        Constant Field Values

    - #### INCOMPATIBLE_STATE

          public static final int INCOMPATIBLE_STATE

      See Also:
        Constant Field Values

    - #### ANALOG_TRIGGER_PULSE_OUTPUT_ERROR

          public static final int ANALOG_TRIGGER_PULSE_OUTPUT_ERROR

      See Also:
        Constant Field Values

    - #### NO_AVAILABLE_RESOURCES

          public static final int NO_AVAILABLE_RESOURCES

      See Also:
        Constant Field Values

    - #### PARAMETER_OUT_OF_RANGE

          public static final int PARAMETER_OUT_OF_RANGE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### HALUtil

          public HALUtil()

  - ### Method Detail

    - #### getFPGAVersion

          public static short getFPGAVersion()

    - #### getFPGARevision

          public static int getFPGARevision()

    - #### getFPGATime

          public static long getFPGATime()

    - #### getHALRuntimeType

          public static int getHALRuntimeType()

    - #### getFPGAButton

          public static boolean getFPGAButton()

    - #### getHALErrorMessage

          public static java.lang.String getHALErrorMessage(int code)

    - #### getHALErrno

          public static int getHALErrno()

    - #### getHALstrerror

          public static java.lang.String getHALstrerror(int errno)

    - #### getHALstrerror

          public static java.lang.String getHALstrerror()